﻿using Syncfusion.Data;
using Syncfusion.DataSource;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.GridCommon;
using Syncfusion.WinForms.ListView.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AdvFilterWF
{
    public partial class Form1 : Form
    {
        private Random r = new Random();
        public DataTable EmployeeCollection;
        public DataTable combodt;
        public Form1()
        {
            InitializeComponent();

            GetDataTable();
            GetComboBoxDataTable();

            //column generated manually in SfDataGrid
            this.sfDataGrid1.AutoGenerateColumns = false;

            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "EmployeeID" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "EmployeeName" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "Destination" });            

            var  colCbo = new GridComboBoxColumn();

            colCbo.AllowDragging = true;

            colCbo.AllowFiltering = true;

            colCbo.AllowResizing = true;

            colCbo.FilterPopupMode = FilterPopupMode.CheckBoxFilter;

            colCbo.HeaderText = "Species";

            colCbo.MappingName = "Country";

            colCbo.DisplayMember = "Country";

            colCbo.ValueMember = "Country";

            colCbo.AutoCompleteMode = AutoCompleteMode.Suggest;

            colCbo.DropDownStyle = DropDownStyle.DropDown;

            colCbo.AutoSuggestMode = AutoCompleteSuggestMode.Contains;

            colCbo.ValidationMode = GridValidationMode.InEdit;

            colCbo.Width = 125;

            colCbo.DataSource = combodt;

            sfDataGrid1.Columns.Add(colCbo);

            this.sfDataGrid1.DataSource = EmployeeCollection;

        }               

        public void GetDataTable()
        {
            EmployeeCollection = new DataTable();
            EmployeeCollection.Columns.Add("EmployeeID", typeof(int));
            EmployeeCollection.Columns.Add("EmployeeName", typeof(string));
            EmployeeCollection.Columns.Add("Destination", typeof(string));
            EmployeeCollection.Columns.Add("Country", typeof(string));

            for (int i = 0; i <= 9; i++)
            {
                System.Data.DataRow row = EmployeeCollection.NewRow();                
                var name_Renamed = employeeName[r.Next(employeeName.Count() - 1)];
                var destinaton = title[r.Next(title.Count() - 1)];
                var city = country[i];
                row[0] = 1000 + i;
                row[1] = name_Renamed;
                row[2] = destinaton;
                row[3] = city;

                EmployeeCollection.Rows.Add(row);
            }
        }


        public void GetComboBoxDataTable()
        {
            combodt = new DataTable();
            combodt.Columns.Add("Country", typeof(string));

            for (int i = 0; i <= 9; i++)
            {
                System.Data.DataRow row = combodt.NewRow();

                var city = country[i];
                row[0] = city;
                combodt.Rows.Add(row);
            }
        }

        private string[] employeeName = new[] { "Sean Jacobson", "Phyllis Allen", "Marvin Allen", "Michael Allen", "Cecil Allison", "Oscar Alpuerto", "Sandra Altamirano", "Selena Alvarad", "Emilio Alvaro", "Maxwell Amland", "Mae Anderson", "Ramona Antrim", "Sabria Appelbaum", "Hannah Arakawa", "Kyley Arbelaez", "Tom Johnston", "Thomas Armstrong", "John Arthur", "Chris Ashton", "Teresa Atkinson", "John Ault", "Robert Avalos", "Stephen Ayers", "Phillip Bacalzo", "Gustavo Achong", "Catherine Abel", "Kim Abercrombie", "Humberto Acevedo", "Pilar Ackerman", "Frances Adams", "Margar Smith", "Carla Adams", "Jay Adams", "Ronald Adina", "Samuel Agcaoili", "James Aguilar", "Robert Ahlering", "Francois Ferrier", "Kim Akers", "Lili Alameda", "Amy Alberts", "Anna Albright", "Milton Albury", "Paul Alcorn", "Gregory Alderson", "J. Phillip Alexander", "Michelle Alexander", "Daniel Blanco", "Cory Booth", "James Bailey" };

        private string[] title = new[] { "Marketing Assistant", "Engineering Manager", "Senior Tool Designer", "Tool Designer", "Marketing Manager", "Production Supervisor - WC60", "Production Technician - WC10", "Design Engineer", "Production Technician - WC10", "Design Engineer", "Vice President of Engineering", "Production Technician - WC10", "Production Supervisor - WC50", "Production Technician - WC10", "Production Supervisor - WC60", "Production Technician - WC10", "Production Supervisor - WC60", "Production Technician - WC10", "Production Technician - WC30", "Production Control Manager", "Production Technician - WC45", "Production Technician - WC45", "Production Technician - WC30", "Production Supervisor - WC10", "Production Technician - WC20", "Production Technician - WC40", "Network Administrator", "Production Technician - WC50", "Human Resources Manager", "Production Technician - WC40", "Production Technician - WC30", "Production Technician - WC30", "Stocker", "Shipping and Receiving Clerk", "Production Technician - WC50", "Production Technician - WC60", "Production Supervisor - WC50", "Production Technician - WC20", "Production Technician - WC45", "Quality Assurance Supervisor", "Information Services Manager", "Production Technician - WC50", "Master Scheduler", "Production Technician - WC40", "Marketing Specialist", "Recruiter", "Production Technician - WC50", "Maintenance Supervisor", "Production Technician - WC30" };


        private string[] country = new[] { "America", "Africa", "Brazil", "China", "Denmark", "Eroupe", "France", "Germany", "Italy", "Japan", "London", "UK", "Mexico", "US" };

        private string[] cities = new[] { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N" };
        
    }
}
